from mutable_pair import mutable_pair

def mylist_iterator(ls):
    while ls != None:
        yield ls
        ls = ls('get', 1)

def my_list():
    contents = None

    def selector_func(msg, arg1 = None, arg2 = None):
        if msg == 'getitem':
            return getitem(arg1)
        elif msg == 'setitem':
            return setitem(arg1, arg2)
        elif msg == 'append':
            return append(arg1)
        elif msg == 'str':
            return to_str()

    def getitem(i):
        count = 0
        for item in mylist_iterator(contents):
            if count == i:
                return item('get', 0)
            count = count + 1

    def setitem(i, value):
        count = 0
        for item in mylist_iterator(contents):
            if count == i:
                return item('set', 0, value)
            count = count + 1

    def append(value):
        nonlocal contents
        if contents == None:
            contents = mutable_pair(value, None)
            return
        for item in mylist_iterator(contents):
            pass
        item('set', 1, mutable_pair(value, None))

    def to_str():
        s = '['
        for item in mylist_iterator(contents):
            s += str(item('get',0)) + ', '
        return s[:-2] + ']'

    return selector_func
